from __future__ import with_statement

import es
import os
import cPickle
import installlib
import datetime
import threading
from operator import truediv # I am not a real fan of __future__.division



update_check_enabled = True


#This addon ONLY supports bans by STEAMID!

info = es.AddonInfo()
info.name = "BanSaver"
info.author = "Brainsucker"
info.description = "Saves NON-Permanent bans. So the bans will not expire at a server restart."
info.url = "http://addons.eventscripts.com/addons/view/bansaver"
info.version = "1.2.9"


l = threading.Lock()


def updatecheck():
	installer = installlib.getInstaller('bansaver')
	
	us = installer.update()
	
	if us == installer.STATUS_SUCCESSFUL:
		es.dbgmsg(0, '[BANSAVER] Updated to new Version (v%s). Please reload the Addon or restart your Server.' % installer.addon.currentversion)
	
	
	
def saveDB():
	with l:
		with open(dbpath, "wb") as f:
			cPickle.dump(bandict, f)
			
			
addonpath = es.getAddonPath('bansaver')
dbpath = os.path.join(addonpath, 'banned_user.db')
bandict = {}
bandict["steamids"] = {}
expired = set()
td = datetime.datetime.today()
try:
	with l:
		with open(dbpath, "rb") as dbf:
			bandict = cPickle.load(dbf)
except:
	pass
else:
	for b in bandict["steamids"].keys():
		remaining_bantime = bandict['steamids'][b]['expiredate'] - td
		remaining_days = remaining_bantime.days
		remaining_seconds = remaining_bantime.seconds + (remaining_days*86400)
		remaining_minutes = truediv(remaining_seconds, 60)
		if remaining_minutes > 0:
			es.server.queuecmd("banid %f %s" % (remaining_minutes, b))
			
		else:
			expired.add(b)
			
	for s in expired:
		del bandict['steamids'][s]
		
	t = threading.Thread(target=saveDB)
	t.start()
if update_check_enabled:
	if es.getplayercount() == 0:
		updatecheck()
es.ServerVar(info["name"], info["version"]).makepublic()

def es_map_start(ev):
	if update_check_enabled:
		updatecheck()


def server_addban(ev):
	steamid = ev["networkid"]
	dur = ev["duration"]
	if dur != "permanently":
		bt_float = str(dur).split()[1]
		bantime = float(bt_float)
		if bantime > 0:
			if not bandict['steamids'].has_key(steamid):
				bandict["steamids"][steamid] = {}
			today = datetime.datetime.today()
			ed = datetime.timedelta(minutes=bantime) + today
			
			
			bandict['steamids'][steamid]['expiredate'] = ed
			t = threading.Thread(target=saveDB)
			t.start()
				
	
def server_removeban(ev):
	steamid = ev["networkid"]
	if bandict["steamids"].has_key(steamid):
		del bandict["steamids"][steamid]
		
	t = threading.Thread(target=saveDB)
	t.start()